function v = biphasic1d(n,k,B,t)
%
% 񑊐(motion-energy model)֐D
% 
%  n      : tB^̒g
%  k      : tB^̎萔
%  B      : ̑ɑ΂镉̑̑΃TCY(0-1)
%  t      : (b)
% 
% v = biphasic1d(n,k,B,t)
% 
% -------------------------------------------------------------------------
%
% gp: 񑊐֐ʂɕ\D
% 
% n      = 6;
% k      = 100;
% B      = 0.8;
% t      = 0:0.001:1; 
% 
% v = biphasic1d(n,k,B,t);	% 񑊐֐쐬 
% plot(t,v);    
%
%--------------------------------------------------------------------------
v = normalize('AbsMax',(k*t).^n.*exp(-k*t).*(1/factorial(n)-B*((k*t).^2)./factorial(n+2)),1);
end
