function im = grating2d(x,y,type,lambda,ori,ph,cnt)
% 
% Cӂ̔g`̊iqp^
%
%  type   : iq̃^Cv(g='Sine' `g='Square' Opg='Triangle' g='Sawtooth' MFg='MF')
%  lambda : iq̔g()
%  ori    : iq̕
%  ph     : iq̈ʑ
%  cnt    : RgXg
% 
% im = grating2d(x,y,type,lambda,ori,ph)
% 
%--------------------------------------------------------------------------
% 
% gp: giqp^[̍쐬A\D
%
% lambda = 64;
% ori    = 30;
% ph     = 0;
% cnt    = 1;
% type   = 'Sawtooth';
% 
% [x,y] = makegrid('Linear',256,256);           % bVObh쐬
% im = grating2d(x,y,type,lambda,ori,ph,cnt);   % g̊iqs쐬
% imshow(lum(im,0.5));                          % `
% 
%--------------------------------------------------------------------------
ori = 90-ori;
if strcmp(type,'Sine')
    im = sin(2*pi.*(x.*cos(ori*pi/180)+y.*sin(ori*pi/180))/lambda+(ph*pi/180)).*cnt;
elseif strcmp(type,'Square')
    im = thr(sin(2*pi.*(x.*cos(ori*pi/180)+y.*sin(ori*pi/180))/lambda+(ph*pi/180)),0,1,-1).*cnt; 
elseif strcmp(type,'Triangle')
    im = (((x.*cos(ori*pi/180)+y.*sin(ori*pi/180)+ph*lambda/360+lambda*0.75)/(lambda*0.5)...
        -ceil((x.*cos(ori*pi/180)+y.*sin(ori*pi/180)+ph*lambda/360+lambda*0.75)/(lambda*0.5)-1)-1/2)...
        .*(-thr(sin(2*pi.*(x.*cos(ori*pi/180)+y.*sin(ori*pi/180)+ph*lambda/360+lambda*0.75)/((lambda*0.5)*2)),0,1,-1)).*2).*cnt;
elseif strcmp(type,'Sawtooth')
    im = (2*((x.*cos(ori*pi/180)+y.*sin(ori*pi/180)+ph*lambda/360+lambda*0.5)/lambda...
        -floor((x.*cos(ori*pi/180)+y.*sin(ori*pi/180)+ph*lambda/360+lambda*0.5)/lambda+1/2))).*cnt;
elseif strcmp(type,'MF')
    im = (thr(sin(2*pi.*(x.*cos(ori*pi/180)+y.*sin(ori*pi/180))/lambda+(ph*pi/180)),0,1,-1)-sin(2*pi.*(x.*cos(ori*pi/180)+y.*sin(ori*pi/180))/lambda+(ph*pi/180))).*cnt; 
else 
    im = 0;
    disp('error! :type̎w肪ł. Sine, Square, Triangle, Sawtootĥꂩw肵Ă.');
end

end