function im = makeGrating2d(type,lambda,ori,ph,cnt,nx,ny,dx,dy)
% 
% Cӂ̔g`̊iqp^
%
%  type   : iq̃^Cv(g='Sine' `g='Square' Opg='Triangle' g='Sawtooth' MFg='MF')
%           ꂼPolarƋɍWpxARadialƋɍWaɂĂ̔g`(̍Wnłori͖)
%  lambda : iq̔g()
%  ori    : iq̕
%  ph     : iq̈ʑ
%  cnt    : RgXg
%  nx     : ̗̈
%  ny     : ̈̍s
%  dx     : sł̒S(0,0)̃Y(Ȃꍇ0)
%  dy     : sł̒S(0,0)̃Y(Ȃꍇ0)
% 
% im = makeGrating2d(type,lambda,ori,ph,cnt,nx,ny,[dx],[dy])
% 
%--------------------------------------------------------------------------
% 
% gp: ggiqp^[ʂɕ\
%
% lambda = 64;
% ori    = 30;
% ph     = 0;
% cnt    = 1;
% type   = 'Sine';
% nx     = 256;
% ny     = 256;
% 
% im = makeGrating2d(type,lambda,ori,ph,cnt,nx,ny); % S~̋g̊iqs쐬
% imshow(lum(im,0.5));                             	% `
% 
%--------------------------------------------------------------------------
if nargin==7
    dx = 0;
    dy = 0;
end
if strcmp(type,'Sine') || strcmp(type,'Square') || strcmp(type,'Triangle') || strcmp(type,'Sawtooth') || strcmp(type,'MF')
    [x,y] = makegrid('Linear',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,type,lambda,ori,ph,cnt);
elseif strcmp(type,'PolarSine')
    [x,y] = makegrid('Polar',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,'Sine',lambda,90,ph,cnt);
elseif strcmp(type,'PolarSquare')
    [x,y] = makegrid('Polar',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,'Square',lambda,90,ph,cnt);
elseif strcmp(type,'PolarTriangle')
    [x,y] = makegrid('Polar',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,'Triangle',lambda,90,ph,cnt);    
elseif strcmp(type,'PolarSawtooth')
    [x,y] = makegrid('Polar',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,'Sawtooth',lambda,90,ph,cnt);   
elseif strcmp(type,'PolarMF')
    [x,y] = makegrid('Polar',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,'MF',lambda,90,ph,cnt);
elseif strcmp(type,'RadialSine')
    [x,y] = makegrid('Polar',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,'Sine',lambda,0,ph,cnt);
elseif strcmp(type,'RadialSquare')
    [x,y] = makegrid('Polar',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,'Square',lambda,0,ph,cnt);
elseif strcmp(type,'RadialTriangle')
    [x,y] = makegrid('Polar',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,'Triangle',lambda,0,ph,cnt);    
elseif strcmp(type,'RadialSawtooth')
    [x,y] = makegrid('Polar',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,'Sawtooth',lambda,0,ph,cnt);   
elseif strcmp(type,'RadialMF')
    [x,y] = makegrid('Polar',nx,ny);
    x = x-dx;
    y = y-dy;
    im = grating2d(x,y,'MF',lambda,0,ph,cnt);    
end

end
