function im = mondrian(x,y,type,maxsize,minsize,number,cnt,color)
%
% hAEp^
%
%  type = 'Rect': evf͒`(Ӓ̓_)
%  type = 'Square': evf͐`
%  type = 'Circle': evf͉~`
% 
%  x:        xTCY
%  y:        yTCY
%  maxsize:  pb`̍őTCY
%  minsize:  pb`̍ŏTCY
%  number:   pb`
%  cnt:      RgXg
%  color:    J[(0-1RGBlwCgpFs𑝂₷)Dw肵Ȃꍇ͔D
% 
% im = mondrian(x,y,type,maxsize,minsize,number,cnt,[color])
% 
% -------------------------------------------------------------------------
% 
% gpFhAwiɉ摜񎦂
% 
% % `pb`̃hA쐬
%   msizex = 512;             % TCY[x]
%   msizey = 512;             % TCY[y]
%   mmax = 64;                % pb`őTCY
%   mmin = 16;                % pb`ŏTCY
%   mnumber = 400;            % pb`
%   mcnt = 1;                 % RgXg
%   bg = mondrian(msizex,msizey,'Rect',mmax,mmin,mnumber,mcnt); % hAEp^쐬
%   bg = lum(bg,0.5);         % Pxlɕϊ
% 
% % 摜̓ǂݍ
%   gamma = 2;                % JK}
%   im0 = loadImage('_image/LENNA.bmp',gamma);    % 摜ǂݍ
% 
% % hAɉ摜d˂
%   cx = 0;                   % 摜d˂ʒu[x]
%   cy = 0;                   % 摜d˂ʒu[y]
%   im = fillLocalImage(bg,im0,cx,cy);            % 摜d˂
%   image(repmat(im,1,1,3));axis image;axis off;  % 摜\
%
% -------------------------------------------------------------------------
%
% gp: ~`pb`̃hA쐬Cꕔ؂o
% 
% % ~`pb`̃hA쐬
%     msizex = 400;     % TCY[x]
%     msizey = 300;     % TCY[y]
%     mmax = 32;        % pb`őTCY
%     mmin = 8;         % pb`ŏTCY
%     mnumber = 100;    % pb`
%     mcnt = 1;         % RgXg
%     mcolor = [1,1,1;1,0,0;0,1,0;0,0,1;1,1,0]; % J[
%     bg = mondrian(msizex,msizey,'Circle',mmax,mmin,mnumber,mcnt,mcolor); % hAEp^쐬
%     bg = lum(bg,0.5); % Pxlɕϊ
%     
% % 摜̐؂o
%     cx = 32;    % imSɑ΂OîW
%     cy = 0;     % imSɑ΂OîW
%     xn = 256;   % ؂o摜TCY[x]
%     yn = 256;   % ؂o摜TCY[y]
%     im = pickLocalImage(bg,cx,cy,xn,yn);  % w͈̔͂̉摜؂o
% 
% % 摜̕\
%     subplot(1,2,1)
%     image(bg);axis image;axis off;        % 摜\
%     subplot(1,2,2)
%     image(im);axis image;axis off;        % ؂o摜\
%  
% -------------------------------------------------------------------------
if nargin < 8
    color = [1,1,1];
    im = zeros(y,x);
elseif size(color,1) == 1
    im = zeros(y,x);
else
    im = zeros(y,x,3);
end

if strcmp(type,'Rect')
    i = 0;
    while i < number
        xsize = round(minsize+rand(1)*(maxsize-minsize));
        ysize = round(minsize+rand(1)*(maxsize-minsize));
        xi = round(rand(1)*2*x-0.5*x);
        yi = round(rand(1)*2*y-0.5*y);
        xe = xi+xsize-1;
        ye = yi+ysize-1;
        if xe > 1 && ye > 1
            if (xi<1) 
                xi = 1; end
            if (yi<1) 
                yi = 1; end
            if (xe>x) 
                xe = x; end
            if (ye>y) 
                ye = y; end
            if size(color,1) == 1
                im(yi:ye,xi:xe) = rand(1);
            else
                col = randi(size(color,1),1);
                for m = 1:3
                    im(yi:ye,xi:xe,m) = color(col,m);
                end
            end
            i = i + 1;
        end
    end
    
elseif strcmp(type,'Square')
    i = 0;
    while i < number    
        xysize = round(minsize+rand(1)*(maxsize-minsize));
        xi = round(rand(1)*2*x-0.5*x);
        yi = round(rand(1)*2*y-0.5*y);
        xe = xi+xysize-1;
        ye = yi+xysize-1;
        if xe > 1 && ye > 1
            if (xi<1) 
                xi = 1; end
            if (yi<1) 
                yi = 1; end
            if (xe>x) 
                xe = x; end
            if (ye>y) 
                ye = y; end
            if size(color,1) == 1
                im(yi:ye,xi:xe) = rand(1);
            else
                col = randi(size(color,1),1);
                for m = 1:3
                    im(yi:ye,xi:xe,m) = color(col,m);
                end
            end
           i = i + 1; 
        end
    end

elseif strcmp(type,'Circle')
    i = 0;
    [gx,gy] = meshgrid((1:x),(1:y));
    while i < number
        xysize = round(minsize+rand(1)*(maxsize-minsize));
        xi = round(rand(1)*2*x-0.5*x);
        yi = round(rand(1)*2*y-0.5*y);
        xe = xi+xysize-1;
        ye = yi+xysize-1;
        if xi <= x && xe >= 1 && yi <=y && ye >=1
            if size(color,1) == 1
                im(hypot(gy-(yi+(xysize-1)/2),gx-(xi+(xysize-1)/2)) <= xysize) = rand(1);
            else
                col = randi(size(color,1),1);
                for m = 1:3
                    imm = im(:,:,m);
                    imm(hypot(gy-(yi+(xysize-1)/2),gx-(xi+(xysize-1)/2)) <= xysize) = color(col,m);
                    im(:,:,m) = imm;
                end                
            end
            i = i + 1;
        end
    end
end
im = (2*im-1).*cnt;
