function [thr,slope,thrse,slopese] = getThreshold(pmf,stim,rsp,chance,pthr,lapse,Nboot,show,centroid,inislope,varargin)
%
% Ŗޖ@ɂ臒lPSE߂
%
%  pmf       : S֐̃^Cv('logistic' 'weibull' 'normal' 'gumbel')
%  stim      : hx
%  rsp       : (=1/=0)
%  chance    : `Xx(0-1)
%  pthr      : 臒lƂ锽(0-1)
%  lapse     : vX[g(0-1)
%  Nboot     : u[gXgbv̉ (>30̏ꍇ̂݁C<=30̏ꍇthrse=0,slopese=0Ԃ)
%  show      : S֐̕\̗L(1/0) 
%  centroid  : dS̏l...ftHgFhl̕
%  inislope  : X̏l...ftHgFWbgϊ̌X(`)
%
% [thr,slope,thrse,slopese] = getThreshold(pmf,stim,rsp,chance,pthr,lapse,Nboot,show,[centroid],[inislope],[varargin])
%
% Palamedes toolbox(Prins & Kingdom, 2009)gp
%
%--------------------------------------------------------------------------
%
% gp: S֐\C臒lCX[vC̃u[gXgbv덷߂D
%
% pmf = 'logistic'; 
% stim = [0.2 0.2 0.2 0.5 0.5 0.5 0.8 0.8 0.8]; 
% rsp = [1 0 0 1 1 0 1 1 1]; 
% pthr = 0.5; 
% chance = 0; 
% lapse = 0; 
% Nboot = 50; 
% show = 1;
% 
% [thr,slope,thrse,slopese] = getThreshold(pmf,stim,rsp,chance,pthr,lapse,Nboot,show);
% display([thr,slope,thrse,slopese]);
% 
%--------------------------------------------------------------------------
% Modified Palamedes toolbox 2016.10.28 by RN
%
%PAL_PFML_Fit   Fit a psychometric function to data using a Maximum 
%    Likelihood criterion.
%
%Syntax: [paramsValues LL exitflag output] = PAL_PFML_Fit(StimLevels, ...
%   NumPos, OutOfNum, searchGrid, paramsFree, PF, {optional arguments})
%
%Input: 
%   'StimLevels': vector containing stimulus levels used.
%
%   'NumPos':
%       vector containing for each of the entries of 'StimLevels' the 
%       number of trials a positive response (e.g., 'yes' or 'correct') was
%       given.
%
%   'OutOfNum': vector containing for each of the entries of 'StimLevels' 
%       the total number of trials.
%
%   'searchGrid': Either a 1x4 vector [threshold slope guess-rate 
%       lapse-rate] containing initial guesses for free parametervalues and 
%       fixed values for fixed parameters or a structure with vector fields 
%       .alpha, .beta, .gamma, .lambda collectively defining a 4D parameter 
%       grid through which to perform a brute-force search for initial 
%       guesses (using PAL_PFML_BruteForceFit). These initial values will
%       serve as seeds for the Nelder-Mead iterative search. Fields for 
%       fixed parameters should be scalars equal to the fixed value. Note 
%       that fields for free parameters may also be scalars in which case 
%       the provided value will serve as the initial value for Nelder-Mead 
%       search. Note that choices made here have a large effect on 
%       processing time and memory usage.
%
%   'paramsFree': 1x4 vector coding which of the four parameters of the PF 
%       [threshold slope guess-rate lapse-rate] are free parameters and 
%       which are fixed parameters (1: free, 0: fixed).
%
%   'PF': psychometric function to be fitted. Passed as an inline function.
%       Options include:    
%           @PAL_Logistic
%           @PAL_Weibull
%           @PAL_Gumbel (i.e., log-Weibull)
%           @PAL_Quick
%           @PAL_logQuick
%           @PAL_CumulativeNormal
%           @PAL_Gumbel
%           @PAL_HyperbolicSecant
%
%Output:
%   'paramsValues': 1x4 vector containing values of fitted and fixed 
%       parameters of the psychometric function [threshold slope guess-rate 
%       lapse-rate].
%
%   'LL': Log likelihood associated with the fit.
%
%   'exitflag': 1 indicates a succesful fit, 0 indicates fit did not
%       converge (trying again using new initial guesses might help).
%
%   'output': message containing some information concerning fitting
%       process.
%
%User may constrain the lapse rate to fall within limited range using 
%   the optional argument 'lapseLimits', followed by two-element vector 
%   containing lower and upper limit respectively. See full example below.
%
%User may constrain the guess rate to fall within limited range using 
%   the optional argument 'guessLimits', followed by two-element vector 
%   containing lower and upper limit respectively. See full example below.
%
%Different fitting schemes may be specified using the optional argument
%   'lapseFits'. Default value is 'nAPLE' (non-Asymptotic Performance Lapse 
%   Estimation), in which all free parameters are estimated jointly in the 
%   manner outlined by e.g., Wichmann & Hill (2001). In case the highest 
%   stimulus value in 'StimLevels' is so high that it can be assumed that 
%   errors at this intensity can only be due to lapses, alternative schemes 
%   may be specified. 'jAPLE' (joint APLE) assumes that errors at
%   highest 'StimLevel' are due exclusively to lapses, and observations at 
%   this intensity contribute only to estimate of lapse rate. Observations 
%   at other values in 'StimLevels' contribute to all free parameters 
%   (including lapse rate). 'iAPLE' (isolated APLE) is identical to 
%   'jAPLE', except that the lapse rate estimate is based on observations 
%   made at the highest 'StimLevel' only. Other parameters are estimated 
%   from observations made at the other values of 'StimLevel' using lapse 
%   rate estimate obtained at highest 'StimLevel' as fixed value. For more
%   information see: http://www.journalofvision.org/content/12/6/25
%
%The guess rate and lapse rate parameter can be constrained to be equal, as 
%   would be appropriate, for example, in a bistable percept task. To 
%   accomplish this, use optional argument 'gammaEQlambda', followed by a 
%   1. Both the guess rate and lapse rate parameters will be fit according 
%   to options set for the lapse rate parameter. Entry for guess rate in 
%   'searchGrid' needs to be made but will be ignored.
%
%PAL_PFML_Fit uses Nelder-Mead Simplex method to find the maximum 
%   in the likelihood function. The default search options may be changed 
%   by using the optional argument 'SearchOptions' followed by an options 
%   structure created using options = PAL_minimize('options'). See example 
%   of usage below. For more information type 
%   PAL_minimize('options','help').
%
%   [paramsValues LL exitflag output] = PAL_PFML_Fit(StimLevels, NumPos, 
%       OutOfNum, searchGrid, paramsFree, PF, 'searchOptions', options)
%
%Full example:
%
%   options = PAL_minimize('options')
%   PF = @PAL_Logistic;
%   StimLevels = [-3:1:3];
%   NumPos = [0 13 28 56 73 91 93];    %observer data
%   OutOfNum = 100.*ones(size(StimLevels));
%   searchGrid.alpha = [-1:.01:1];    %structure defining grid to
%   searchGrid.beta = 10.^[-1:.01:2]; %search for initial values
%   searchGrid.gamma = [0:.01:.06];
%   searchGrid.lambda = [0:.01:.06];
%
%   %or (not advised):
%   % searchGrid = [0 1 0.01 0.01];       %Guesses
%
%   paramsFree = [1 1 1 1];
%
%   %Fit data:
%
%   paramsValues = PAL_PFML_Fit(StimLevels, NumPos, OutOfNum, ...
%       searchGrid, paramsFree, PF,'lapseLimits',[0 1],'guessLimits',...
%       [0 1], 'searchOptions',options)
%
% Introduced: Palamedes version 1.0.0 (NP)
% Modified: Palamedes version 1.0.2, 1.2.0, 1.3.0, 1.3.1, 1.4.0, 1.6.3
%   (see History.m)

StimLevels = unique(stim);
correct = stim(rsp==1);
for i = 1:length(StimLevels)
    NumPos(i) = length(correct(correct==StimLevels(i)));
    OutOfNum(i) = length(stim(stim==StimLevels(i)));
end
PropCorrectData = NumPos./OutOfNum;
if strcmp(pmf,'logistic')
    PF = @PAL_Logistic;
elseif strcmp(pmf,'weibull')
    PF = @PAL_Weibull;
elseif strcmp(pmf,'normal')
    PF = @PAL_CumulativeNormal;
elseif strcmp(pmf,'gumbel')
    PF = @PAL_Gumbel;
end
if exist('centroid','var') && ~isempty(centroid)
    centroid = centroid;
else
    centroid = mean(stim); % dS̏l[ftHgl]
end
if exist('inislope','var') && ~isempty(inislope)
    inislope = inislope;
else
    inislope =median(gradient(clip(logit(PropCorrectData),3,-3),mean(gradient(StimLevels)))); % X̏l[ftHgl]
end
searchGrid = [centroid inislope chance lapse];	% [centroid slope guess-rate lapse-rate]
paramsFree = [1 1 0 0];                         % 1:free/0:fixed
% -------------------------------------------------------------------------
% -------------------------------------------------------------------------
options = [];
lapseLimits = [];
guessLimits = [];
lapseFit = 'default';
gammaEQlambda = logical(false);

if ~isempty(varargin)
    NumOpts = length(varargin);
    for n = 1:2:NumOpts
        valid = 0;
        if strncmpi(varargin{n}, 'SearchOptions',7)
            options = varargin{n+1};
            valid = 1;
        end
        if strncmpi(varargin{n}, 'lapseLimits',6)
            if paramsFree(4) == 0 && ~isempty(varargin{n+1})
                warning('PALAMEDES:invalidOption','Lapse rate is not a free parameter: ''LapseLimits'' argument ignored');
            else
                lapseLimits = varargin{n+1};
            end
            valid = 1;
        end
        if strncmpi(varargin{n}, 'guessLimits',6)
            if paramsFree(3) == 0 && ~isempty(varargin{n+1})
                warning('PALAMEDES:invalidOption','Guess rate is not a free parameter: ''GuessLimits'' argument ignored');
            else
                guessLimits = varargin{n+1};
            end
            valid = 1;
        end
        if strncmpi(varargin{n}, 'lapseFit',6)
            if paramsFree(4) == 0 && ~strncmpi(varargin{n+1},'def',3)
                warning('PALAMEDES:invalidOption','Lapse rate is not a free parameter: ''LapseFit'' argument ignored');
            else
                lapseFit = varargin{n+1};
            end
            valid = 1;
        end
        if strncmpi(varargin{n}, 'gammaEQlambda',6)
            gammaEQlambda = logical(varargin{n+1});
            valid = 1;
        end
        if valid == 0
            warning('PALAMEDES:invalidOption','%s is not a valid option. Ignored.',varargin{n});
        end        
    end            
end

if ~isempty(guessLimits) && gammaEQlambda
    warning('PALAMEDES:invalidOption','Guess rate is constrained to equal lapse rate: ''guessLimits'' argument ignored');
    guessLimits = [];
end

[StimLevels, NumPos, OutOfNum] = PAL_PFML_GroupTrialsbyX(StimLevels, NumPos, OutOfNum);

if isstruct(searchGrid)
    if gammaEQlambda
        searchGrid.gamma = 0;
    end
    searchGrid = PAL_PFML_BruteForceFit(StimLevels, NumPos, OutOfNum, searchGrid, PF, 'lapseFit',lapseFit,'gammaEQlambda',gammaEQlambda);
end

if gammaEQlambda
    searchGrid(3) = searchGrid(4);
    paramsFree(3) = 0;
end

paramsFreeVals = searchGrid(paramsFree == 1);
paramsFixedVals = searchGrid(paramsFree == 0);

if isempty(paramsFreeVals)
    negLL = PAL_PFML_negLL(paramsFreeVals, paramsFixedVals, paramsFree, StimLevels, NumPos, OutOfNum, PF,'lapseFit',lapseFit);
    exitflag = 1;
    output = [];
else
    switch lower(lapseFit(1:3))
        case 'iap'
            len = length(NumPos);        
            if ~gammaEQlambda
                lambda = 1 - NumPos(len)./OutOfNum(len);
                if ~isempty(lapseLimits)
                    lambda = min(lambda,lapseLimits(2));
                    lambda = max(lambda,lapseLimits(1));
                end
                paramsFixedVals(length(paramsFixedVals)+1) = lambda; %lapse rate
                paramsFreeVals = paramsFreeVals(1:length(paramsFreeVals)-1);    %set lapse rate estimate as fixed value
                paramsFree(4) = 0;               
                [paramsFreeVals, negLL, exitflag, output] = PAL_minimize(@PAL_PFML_negLL, paramsFreeVals, options, paramsFixedVals, paramsFree, StimLevels(1:len-1), NumPos(1:len-1), OutOfNum(1:len-1), PF,'gammaEQlambda',gammaEQlambda,'guessLimits',guessLimits);        
                negLL = negLL - log((1 - lambda).^NumPos(len)) - log(lambda.^(OutOfNum(len)-NumPos(len)));
            else
                lambda = 1 - (NumPos(len)+(OutOfNum(1)-NumPos(1)))./(OutOfNum(len)+OutOfNum(1));                
                if ~isempty(lapseLimits)
                    lambda = min(lambda,lapseLimits(2));
                    lambda = max(lambda,lapseLimits(1));
                end
                paramsFixedVals(length(paramsFixedVals)+1) = lambda;
                paramsFixedVals(length(paramsFixedVals)) = lambda;
                paramsFreeVals = paramsFreeVals(1:length(paramsFreeVals)-1);
                paramsFree(4) = 0;
                [paramsFreeVals, negLL, exitflag, output] = PAL_minimize(@PAL_PFML_negLL, paramsFreeVals, options, paramsFixedVals, paramsFree, StimLevels(2:len-1), NumPos(2:len-1), OutOfNum(2:len-1), PF,'gammaEQlambda',gammaEQlambda);        
                negLL = negLL - log((1 - lambda).^(NumPos(len)+(OutOfNum(1)-NumPos(1)))) - log(lambda.^(OutOfNum(len)-NumPos(len)+NumPos(1)));
            end            
        case {'nap', 'jap', 'def'}
            [paramsFreeVals, negLL, exitflag, output] = PAL_minimize(@PAL_PFML_negLL, paramsFreeVals, options, paramsFixedVals, paramsFree, StimLevels, NumPos, OutOfNum, PF,'lapseLimits',lapseLimits,'guessLimits',guessLimits,'lapseFit',lapseFit,'gammaEQlambda',gammaEQlambda);
    end
end

paramsValues = zeros(1,4);
paramsValues(paramsFree == 1) = paramsFreeVals;
paramsValues(paramsFree == 0) = paramsFixedVals;

if gammaEQlambda
    paramsValues(3) = paramsValues(4);
end

LL = -1*negLL;
% -------------------------------------------------------------------------
% -------------------------------------------------------------------------
if strcmp(pmf,'logistic')
    thr = PAL_Logistic(paramsValues,pthr,'Inverse');
elseif strcmp(pmf,'weibull')
    thr = PAL_Weibull(paramsValues,pthr,'Inverse');
elseif strcmp(pmf,'normal')
    thr = PAL_CumulativeNormal(paramsValues,pthr,'Inverse');
elseif strcmp(pmf,'gumbel')
    thr = PAL_Gumbel(paramsValues,pthr,'Inverse');
end
slope = paramsValues(2);
StimLevelsfine = [min(StimLevels):(max(StimLevels)-min(StimLevels))/1000:max(StimLevels)];
Fit = PF(paramsValues,StimLevelsfine);
if Nboot > 30
% -------------------------------------------------------------------------
% -------------------------------------------------------------------------
searchGrid = paramsValues;

options = [];
maxTries = 1;
rangeTries = [1 1 1 1];
lapseLimits = [];
guessLimits = [];
lapseFit = 'default';
gammaEQlambda = logical(false);

paramsSim = zeros(Nboot,4);
LLSim = zeros(Nboot,1);
converged = false(Nboot,1);

if ~isempty(varargin)
    NumOpts = length(varargin);
    for n = 1:2:NumOpts
        valid = 0;
        if strncmpi(varargin{n}, 'SearchOptions',7)
            options = varargin{n+1};
            valid = 1;
        end
        if strncmpi(varargin{n}, 'maxTries',4)
            maxTries = varargin{n+1};
            valid = 1;
        end
        if strncmpi(varargin{n}, 'rangeTries',6)
            rangeTries = varargin{n+1};
            valid = 1;
        end
        if strncmpi(varargin{n}, 'lapseLimits',6)
            if paramsFree(4) == 1
                lapseLimits = varargin{n+1};
            else
                warning('PALAMEDES:invalidOption','Lapse rate is not a free parameter: ''LapseLimits'' argument ignored');
            end
            valid = 1;
        end
        if strncmpi(varargin{n}, 'guessLimits',6)
            if paramsFree(3) == 1
                guessLimits = varargin{n+1};
            else
                warning('PALAMEDES:invalidOption','Guess rate is not a free parameter: ''GuessLimits'' argument ignored');
            end
            valid = 1;
        end
        if strncmpi(varargin{n}, 'searchGrid',8)
            searchGrid = varargin{n+1};
            valid = 1;
        end
        if strncmpi(varargin{n}, 'lapseFit',6)
            if paramsFree(4) == 0
                warning('PALAMEDES:invalidOption','Lapse rate is not a free parameter: ''LapseFit'' argument ignored');
            else
                lapseFit = varargin{n+1};
            end
            valid = 1;
        end
        if strncmpi(varargin{n}, 'gammaEQlambda',6)
            gammaEQlambda = logical(varargin{n+1});
            if gammaEQlambda                
                if paramsValues(3) ~= paramsValues(4)
                    paramsValues(3) = paramsValues(4);
                    warning('PALAMEDES:invalidOption','Generating gamma value changed to %s in order to match lapse value.',num2str(paramsValues(3)));
                end                
            valid = 1;
            end
        end        
        if valid == 0
            warning('PALAMEDES:invalidOption','%s is not a valid option. Ignored.',varargin{n});
        end
    end            
end

if ~isempty(guessLimits) && gammaEQlambda
    warning('PALAMEDES:invalidOption','Guess rate is constrained to equal lapse rate: ''guessLimits'' argument ignored');
    guessLimits = [];
end

if ~isstruct(searchGrid)
    message = ['Option to use generating parameter values as initial '];    
    message = [message 'guesses in fitting procedure will be removed in '];
    message = [message 'some future version of Palamedes. Instead use '];
    message = [message 'optional argument ''searchGrid'' to pass a '];
    message = [message 'structure defining a 4D parameter space through '];
    message = [message 'which to search for initial search values using a '];
    message = [message 'brute force search. Type help '];
    message = [message 'PAL_PFML_BootstrapParametric for more information.'];
    warning('PALAMEDES:useSearchGrid',message);
    warning('off','PALAMEDES:useSearchgrid');
end

[StimLevels, trash, OutOfNum] = PAL_PFML_GroupTrialsbyX(StimLevels, ones(size(StimLevels)), OutOfNum);

if isstruct(searchGrid)
    
    if gammaEQlambda
        searchGrid.gamma = 0;
    end    
    
    [paramsGrid.alpha, paramsGrid.beta, paramsGrid.gamma, paramsGrid.lambda] = ndgrid(searchGrid.alpha,searchGrid.beta,searchGrid.gamma,searchGrid.lambda);

    singletonDim = uint16(size(paramsGrid.alpha) == 1);    
    
    [paramsGrid.alpha] = squeeze(paramsGrid.alpha);
    [paramsGrid.beta] = squeeze(paramsGrid.beta);
    [paramsGrid.gamma] = squeeze(paramsGrid.gamma);
    [paramsGrid.lambda] = squeeze(paramsGrid.lambda);

    if gammaEQlambda
        paramsGrid.gamma = paramsGrid.lambda;
    end    
    
    for level = 1:length(StimLevels)
        logpcorrect(level,:,:,:,:) = log(PF(paramsGrid,StimLevels(1,level)));
        logpincorrect(level,:,:,:,:) = log(1-PF(paramsGrid,StimLevels(1,level)));
    end
else
    paramsGuess = paramsValues;
    if gammaEQlambda
        paramsGuess(3) = paramsGuess(4);
        paramsFree(3) = 0;
    end    
end
    
for b = 1:Nboot
    
    %Simulate experiment
    NumPosSim = PAL_PF_SimulateObserverParametric(paramsValues, StimLevels, OutOfNum, PF,'lapseFit',lapseFit,'gammaEQlambda',gammaEQlambda);

    if isstruct(searchGrid)
        
        LLspace = zeros(size(paramsGrid.alpha,1),size(paramsGrid.alpha,2),size(paramsGrid.alpha,3),size(paramsGrid.alpha,4));

        if size(LLspace,2) == 1 && ndims(LLspace) == 2
            LLspace = LLspace';
        end

        switch lower(lapseFit(1:3))
            case {'nap', 'def'}
                for level = 1:length(StimLevels)
                   LLspace = LLspace + NumPosSim(level).*squeeze(logpcorrect(level,:,:,:,:))+(OutOfNum(level)-NumPosSim(level)).*squeeze(logpincorrect(level,:,:,:,:));
                end
            case {'jap','iap'}
                len = length(NumPosSim);                            
                LLspace = log((1-paramsGrid.lambda).^NumPosSim(len))+log(paramsGrid.lambda.^(OutOfNum(len)-NumPosSim(len))); %0*log(0) evaluates to NaN, log(0.^0) does not
                if gammaEQlambda
                    LLspace = LLspace + log(paramsGrid.lambda.^NumPosSim(1)) + log((1-paramsGrid.lambda).^(OutOfNum(1)-NumPosSim(1)));
                end
                for level = 1+gammaEQlambda:len-1
                    LLspace = LLspace + NumPosSim(level).*squeeze(logpcorrect(level,:,:,:,:))+(OutOfNum(level)-NumPosSim(level)).*squeeze(logpincorrect(level,:,:,:,:));
                end    
        end

        if isvector(LLspace)
            [maxim, Itemp] = max(LLspace);
        else
            if strncmpi(lapseFit,'iap',3)
                [trash, lapseIndex] = min(abs(searchGrid.lambda-(1-NumPosSim(len)/OutOfNum(len))));
                LLspace = shiftdim(LLspace,length(size(LLspace))-1);
                [maxim, Itemp] = PAL_findMax(LLspace(lapseIndex,:,:,:));
                Itemp = circshift(Itemp',length(size(LLspace))-1)';
            else
                [maxim, Itemp] = PAL_findMax(LLspace);
            end
        end
        
        I = ones(1,4);
        
        I(singletonDim == 0) = Itemp;
        
        paramsGuess = [searchGrid.alpha(I(1)) searchGrid.beta(I(2)) searchGrid.gamma(I(3)) searchGrid.lambda(I(4))];
        if strncmpi(lapseFit,'iap',3)
            paramsGuess(4) = 1-NumPosSim(len)/OutOfNum(len);
        end
    end
    
    [paramsSim(b,:), LLSim(b,:), converged(b)] = PAL_PFML_Fit(StimLevels, NumPosSim, OutOfNum, paramsGuess, paramsFree, PF, 'SearchOptions', options,'lapseLimits',lapseLimits,'guessLimits',guessLimits,'lapseFit',lapseFit,'gammaEQlambda',gammaEQlambda);

    if ~isstruct(searchGrid) 
        tries = 1;
        while converged(b) == 0 && tries < maxTries
                NewSearchInitials = searchGrid+(rand(1,4)-.5).*rangeTries.*paramsFree;
                [paramsSim(b,:), LLSim(b,:), converged(b)] = PAL_PFML_Fit(StimLevels, NumPosSim, OutOfNum, NewSearchInitials, paramsFree, PF, 'SearchOptions', options,'lapseLimits',lapseLimits,'guessLimits',guessLimits,'lapseFit',lapseFit,'gammaEQlambda',gammaEQlambda);
                tries = tries + 1;            
        end
    end    
    if ~converged(b)
        warning('PALAMEDES:convergeFail','Fit to simulation %s of %s did not converge.',int2str(b), int2str(Nboot));
    end
    % ---------------------------------------------------------------------
    % added by RN 31/10/2016
    thr_sim(b) = PAL_Logistic(paramsSim(b,:),pthr,'Inverse');
    % ---------------------------------------------------------------------
end

exitflag = sum(converged) == Nboot;
if exitflag ~= 1
    warning('PALAMEDES:convergeFail','Only %s of %s simulations converged.',int2str(sum(converged)), int2str(Nboot));
end

[Mean, SD] = PAL_MeanSDSSandSE(paramsSim);
% -------------------------------------------------------------------------
% -------------------------------------------------------------------------
    thrse = std(thr_sim);
    slopese = SD(2);
else
    thrse = 0;
    slopese = 0;
end
if show==1
    figure;
    plot(StimLevelsfine,Fit,'k-','linewidth',2);
    hold on;
    plot(StimLevels,PropCorrectData,'r.','markersize',20);
    ylim([0 1]);
end

end