function v = grating1d(x,type,lambda,ph,cnt)
% 
% Cӂ̔g`

%
%  type   : iq̃^Cv(g='Sine' `g='Square' Opg='Triangle' g='Sawtooth' MFg='MF')
%  lambda : iq̔gij
%  ph     : iq̈ʑ
%  cnt    : RgXg
% 
% v = grating1d(x,type,lambda,ph,cnt)
% 
%--------------------------------------------------------------------------
%
% gp: g֐ʂɕ\D
% 
% x      = (-100:100);
% lambda = 32;
% ph     = 0;
% cnt    = 0.4;
% type   = 'Sine';
% 
% v = grating1d(x,type,lambda,ph,cnt);  % g֐쐬
% plot(x,v);                            % \
% 
%--------------------------------------------------------------------------
if strcmp(type,'Sine')
    v = sin(2*pi*x/lambda+(ph*pi/180)).*cnt;
elseif strcmp(type,'Square')
    v = thr(sin(2*pi*x/lambda+(ph*pi/180)),0,1,-1).*cnt;
elseif strcmp(type,'Triangle')
    v = ((x+ph*lambda/360+lambda*1.25)/(lambda*0.5)-ceil((x+ph*lambda/360+lambda*1.25)/(lambda*0.5)-1)-1/2)...
        .*(-thr(sin(2*pi*x/lambda+((ph+270)*pi/180)),0,1,-1)).*2;
    for i = 1:size(v,2)-1
        if i==1
            if abs(v(i)-v(i+1)) > 0.5
                v(i) = -v(i);
            end
        else
            if abs(v(i)-v(i-1)) > 0.5
                v(i) = -v(i);
            end
        end
    end
    v = v.*cnt;
elseif strcmp(type,'Sawtooth')
    v = (((x+ph*lambda/360)/lambda-floor((x+ph*lambda/360)/lambda+1/2)).*2).*cnt;
elseif strcmp(type,'MF')
    v = (thr(sin(2*pi*x/lambda+(ph*pi/180)),0,1,-1)-sin(2*pi*x/lambda+(ph*pi/180))).*cnt;
else 
    v = 0;
    disp('error! :type̎w肪ł. Sine, Square, Triangle, Sawtootĥꂩw肵Ă.');
end

end