function im = makeCharacters(characters,size,nx,ny,bg,strcol,font,bold)
% 
% 
%
%  characters : 
%  size       : tHgTCY
%  nx         : ̗̈
%  ny         : ̈̍s
%  bg         : wiF[gray or RGB]...ftHgF0.5
%  strcol     : F[gray or RGB]...ftHgF1
%  font       : tHg(PTB̃tHgގQ)...ftHgF'Arial'
%  bold       : ׎:0 or :1...ftHgF0
%
% im = makeCharacters(characters,size,nx,ny,[bg],[strcol],[font],[bold])
%
% 炩initExp(܂PTBopen onscreen)Ȃ
%
%--------------------------------------------------------------------------
%
% gp: ʂɕ\
% 
% characters  = 'ABC';
% size        = 100;
% nx          = 512;
% ny          = 256;
% 
% [window,windowRect] = Screen('OpenWindow',0,[],[],[],2); 	% IXN[
% im = makeCharacters(characters,size,nx,ny);               % 쐬
% Screen('CloseAll');                                       % XN[
% imshow(lum(im,0.5));                                   	% `
% 
%--------------------------------------------------------------------------
global VTB_bgCol VTB_strCol
if exist('bg','var') && ~isempty(bg)
    if length(bg)>1
        bg = bg;
    else
        bg = repmat(bg,1,3);    
    end
elseif isempty(VTB_bgCol)
    bg = [0.5 0.5 0.5];
else
    bg = VTB_bgCol;
end
if exist('strcol','var') && ~isempty(strcol)
    if length(strcol)>1
        strcol = strcol;
    else
        strcol = repmat(strcol,1,3);    
    end
elseif isempty(VTB_strCol)
    strcol = [1 1 1];
else
    strcol = VTB_strCol;
end
if exist('font','var') && ~isempty(font)
    font = font;
else
    font = 'Arial';
end
if exist('bold','var') && ~isempty(bold)
    bold = bold;
else
    bold = 0;
end

window = Screen('OpenOffscreenWindow',-1,0,[0 0 nx ny]); % ItXN[J
Screen('Preference', 'DefaultTextYPositionIsBaseline',0);
Screen('TextFont',window,font);
Screen('TextStyle',window,bold);
Screen('TextSize',window,size);
Screen('FillRect',window,bg*254);
DrawFormattedText(window,double(characters),'center','center',strcol*254);
im = cnt(double(Screen('GetImage',window))./254,0.5);

end