function k = makefilter1d(type,fsize,cpi,fbw)
% 
% gtB^
% 
%  fsize  : gtB^̃TCY
%
%  type = 'Bandpass'̂Ƃ
%  cpi    : ʉߒSg(cycle/image)
%  fbw    : ʉߑш̔lS(octave:0ȉƂ͎Ƃ)
%
%  type = 'Lowpass'̂Ƃ
%  cpi    : ʉߏg(cycle/image)
%  fbw    : JbgItш̔lS(octave)
%
%  type = 'Highpass'̂Ƃ
%  cpi    : ʉ߉g(cycle/image)
%  fbw    : JbgItш̔lS(octave)
%
%  type = 'Fractal'̂Ƃ
%  cpi    : 
%  fbw    : gʉߓ̃X[v
% 
% k = makefilter2d(type,fsize,cpi,fbw)
%
%--------------------------------------------------------------------------
% 
% gp: ohpXmCYg̍쐬
% 
% fsize        = 256;
% type         = 'Bandpass';
% cpi          = 10;
% fbw          = 3;
% 
% k = makefilter1d(type,fsize,cpi,fbw);        % ohpXtB^쐬
% ri = rand(1,256);                            % _mCY쐬
% ci = cnt(ri,mean(ri));                       % RgXglɕϊ
% fi = filter1d(ci,k,'Freq');                  % tB^O
% plot(lum(real(fi),mean(ri)))                 % Pxlɒĕ`
% 
%--------------------------------------------------------------------------
f = abs(-(fsize-1)*0.5:(fsize-1)*0.5);
if strcmp(type,'Bandpass')
    if fbw>0
        k = exp(-(log2(f)-log2(cpi)).^2  / (2.*(fwmh2sd(fbw).^2)));
    else
        k = 1;
    end
elseif strcmp(type,'Lowpass')
    k = exp(-(log2(f)-log2(cpi)).^2  / (2.*(fwmh2sd(fbw).^2)));
    k(f<=cpi) = 1;
elseif strcmp(type,'Highpass')
    k = exp(-(log2(f)-log2(cpi)).^2  / (2.*(fwmh2sd(fbw).^2)));
    k(f>=cpi) = 1;
elseif strcmp(type,'Fractal')
    k = 1./(f.^fbw);
end

end