function im = noise2d(x,y,type,sd)
% 
% emCY
%
%  type   : ̃^Cv(='Uniform' l='Binary' K='Gaussian')
%  sd     : K̕W΍(Ȃꍇdefault=1)
% 
% im = noise2d(x,y,type,[sd])
% 
%--------------------------------------------------------------------------
% 
% gp: mCYEp^(0.7)`ʂɕ\D
%
% x      = 256;
% y      = 256;
% type   = 'Uniform';
% arg    = 0.7;
% 
% im = noise2d(x,y,type,sd);     	% mCYEp^쐬 
% im = normalize('Mean',im,arg);  	% ς0.7ƂȂ悤ŜVtg
% imshow(lum(im,0.5));          	% `
% 
%--------------------------------------------------------------------------
if nargin==3
    sd = 1;
end
im = zeros(y,x);
if strcmp(type,'Uniform')
    m = Shuffle(linspace(-1,1,x*y));
elseif strcmp(type,'Binary')
    m = Shuffle(repmat([-1 1],1,ceil(x*y/2)));
elseif strcmp(type,'Gaussian')
    mm = gauss1d(linspace(-x*y*0.5,x*y*0.5,x*y),sd,1);
    for i =1:size(mm,2)
        m(i) = sum(mm(1:i));
    end
    m = Shuffle(m/max(abs(m))*2-1);
end
for i = 1:x
    for j = 1:y
        im(j,i) = m(x*(j-1)+i);
    end
end

end
